var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
System.register("database/types", [], function (exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [],
        execute: function () {
            ;
        }
    };
});
System.register("database/create_database_value", ["database/value_array", "database/value_object"], function (exports_2, context_2) {
    "use strict";
    var value_array_1, value_object_1;
    var __moduleName = context_2 && context_2.id;
    /**
     * Implementation for the createDatabaseValue function
     *
     * @author Nicolas Schmidt
     * @param val 🏡 the value to create a database-value from
     * @returns the database-value
     *
     */
    function createDatabaseValue(val) {
        if (val instanceof value_object_1.DatabaseObject || val instanceof value_array_1.DatabaseArray)
            return val;
        if (val instanceof Array)
            return new value_array_1.DatabaseArray(val);
        if (val instanceof Object)
            return new value_object_1.DatabaseObject(val);
        return val;
    }
    exports_2("createDatabaseValue", createDatabaseValue);
    return {
        setters: [
            function (value_array_1_1) {
                value_array_1 = value_array_1_1;
            },
            function (value_object_1_1) {
                value_object_1 = value_object_1_1;
            }
        ],
        execute: function () {
        }
    };
});
System.register("database/get_normal_value", ["database/value_array", "database/value_object"], function (exports_3, context_3) {
    "use strict";
    var value_array_2, value_object_2;
    var __moduleName = context_3 && context_3.id;
    /**
     * [implementation]
     * creates the 'normal' value from database-objects
     *
     * @author Nicolas Schmidt
     * @param val 🏡 the value you want to convert back to a normal value
     * @returns the 'normal' value
     *
     * @see getNormalValue
     *
     */
    function getNormalValue(val) {
        if (val instanceof value_object_2.DatabaseObject || val instanceof value_array_2.DatabaseArray)
            return val.data;
        else
            return val;
    }
    exports_3("getNormalValue", getNormalValue);
    return {
        setters: [
            function (value_array_2_1) {
                value_array_2 = value_array_2_1;
            },
            function (value_object_2_1) {
                value_object_2 = value_object_2_1;
            }
        ],
        execute: function () {
        }
    };
});
System.register("database/_functions", ["database/value_array", "database/value_object"], function (exports_4, context_4) {
    "use strict";
    var value_array_3, value_object_3, numberCharacters;
    var __moduleName = context_4 && context_4.id;
    function createObjectForKey(key) {
        if (typeof key == "string")
            return createObjectForKey(key.split(/[.\[\]]/g));
        console.log(key[1]);
        if (typeof key[1] == 'number' || (typeof key[1] == 'string' && isNumberString(key[1])))
            return new value_array_3.DatabaseArray([]);
        return new value_object_3.DatabaseObject();
    }
    exports_4("createObjectForKey", createObjectForKey);
    function isNumberString(s) {
        for (var i = 0; i < s.length; i++)
            if (!numberCharacters.includes(s.charAt(i)))
                return false;
        return true;
    }
    exports_4("isNumberString", isNumberString);
    return {
        setters: [
            function (value_array_3_1) {
                value_array_3 = value_array_3_1;
            },
            function (value_object_3_1) {
                value_object_3 = value_object_3_1;
            }
        ],
        execute: function () {
            exports_4("numberCharacters", numberCharacters = "0123456789");
        }
    };
});
System.register("database/value_array", ["database/value_object", "database/create_database_value", "database/get_normal_value", "database/_functions"], function (exports_5, context_5) {
    "use strict";
    var value_object_4, create_database_value_1, get_normal_value_1, _functions_1, DatabaseArray;
    var __moduleName = context_5 && context_5.id;
    return {
        setters: [
            function (value_object_4_1) {
                value_object_4 = value_object_4_1;
            },
            function (create_database_value_1_1) {
                create_database_value_1 = create_database_value_1_1;
            },
            function (get_normal_value_1_1) {
                get_normal_value_1 = get_normal_value_1_1;
            },
            function (_functions_1_1) {
                _functions_1 = _functions_1_1;
            }
        ],
        execute: function () {
            /**
             * A DatabaseArray is the database-representation of an array.
             *
             * @author Nicolas Schmidt
             *
             * @see DatabaseArray.data
             * @see DatabaseArray.constructor
             * @see DatabaseArray.set - sets a value from the DatabaseArray
             * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
             * @see DatabaseArray.get - gets a value from the DatabaseArray
             * @see DatabaseArray.getNormal - gets a value from the DatabaseArray and normalizes it
             * @see DatabaseArray.update - updates a value from the DatabaseArray
             * @see DatabaseArray.contains - checks if the DatabaseArray contains a value
             * @see DatabaseArray.push - push a value into the DatabaseArray
             */
            DatabaseArray = /** @class */ (function () {
                /**
                 * Constructor for DatabaseArray
                 *
                 * @author Nicolas Schmidt
                 * @param data the data for the database-array
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.data - the argument you give to the constructor
                 *
                 */
                function DatabaseArray(data) {
                    if (data === void 0) { data = []; }
                    this.data = data;
                }
                Object.defineProperty(DatabaseArray.prototype, "data", {
                    get: function () {
                        var data = [];
                        for (var i = 0; i < this._data.length; i++)
                            data[i] = get_normal_value_1.getNormalValue(this._data[i]);
                        return data;
                    },
                    /**
                     * The data of the DatabaseArray
                     *
                     * @author Nicolas Schmidt
                     *
                     * @see DatabaseArray - 👩‍👦 the parent class
                     * @see DatabaseArray._data - the storage for the data
                     *
                     */
                    set: function (data) {
                        var _this = this;
                        this._data = [];
                        data.forEach(function (v, k) { return _this._data[k] = create_database_value_1.createDatabaseValue(v); });
                    },
                    enumerable: false,
                    configurable: true
                });
                Object.defineProperty(DatabaseArray.prototype, "length", {
                    /**
                     * Returns the length of the array
                     *
                     * @author Nicolas Schmidt
                     *
                     * @see DatabaseArray - 👩‍👦 the parent class
                     * @see DatabaseArray.data - the data of the array
                     *
                     */
                    get: function () {
                        return this._data.length;
                    },
                    enumerable: false,
                    configurable: true
                });
                /**
                 * Sets a value from the DatabaseArray.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to apply the value to
                 * @param value the value to apply to the given path
                 * @returns the DatabaseArray itself, so you can chain operations like that
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
                 * @see DatabaseArray.get - gets a value from the DatabaseArray
                 * @see DatabaseArray.getNormal - gets a value from the DatabaseArray and normalizes it
                 * @see DatabaseArray.update - updates a value from the DatabaseArray
                 * @see DatabaseArray.contains - checks if the DatabaseArray contains a value
                 * @see DatabaseArray.push - push a value into the DatabaseArray
                 *
                 */
                DatabaseArray.prototype.set = function (key, value) {
                    if (typeof key == "string")
                        this.set(key.split(/[.\[\]]/g), value);
                    else if (typeof key == "number")
                        this._data[key] = create_database_value_1.createDatabaseValue(value);
                    else {
                        if (key.length > 1) {
                            if (this._data[key[0]] == null)
                                this._data[key[0]] = _functions_1.createObjectForKey(key);
                            var e = this._data[key[0]];
                            if (!(e instanceof value_object_4.DatabaseObject || e instanceof DatabaseArray))
                                throw new Error("Can't use set property of " + typeof e);
                            e.set(key.slice(1, key.length), value);
                        }
                        else {
                            this._data[typeof key[0] == "string" ? parseInt(key[0]) : key[0]] = create_database_value_1.createDatabaseValue(value);
                        }
                    }
                    return this;
                };
                /**
                 * Sets a default value from the DatabaseArray.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to apply the value to
                 * @param value the value to apply to the given path
                 * @returns the DatabaseArray itself, so you can chain operations like that
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.set - sets a value from the DatabaseArray
                 * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
                 * @see DatabaseArray.get - gets a value from the DatabaseArray
                 * @see DatabaseArray.getNormal - gets a value from the DatabaseArray and normalizes it
                 * @see DatabaseArray.update - updates a value from the DatabaseArray
                 * @see DatabaseArray.contains - checks if the DatabaseArray contains a value
                 * @see DatabaseArray.push - push a value into the DatabaseArray
                 *
                 */
                DatabaseArray.prototype.setDefault = function (key, value) {
                    if (!this.contains(key))
                        this.set(key, value);
                    return this;
                };
                /**
                 * Gets a value from the DatabaseArray.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to get
                 * @returns the value of the key
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.set - sets a value from the DatabaseArray
                 * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
                 * @see DatabaseArray.getNormal - gets a value from the DatabaseArray and normalizes it
                 * @see DatabaseArray.update - updates a value from the DatabaseArray
                 * @see DatabaseArray.contains - checks if the DatabaseArray contains a value
                 * @see DatabaseArray.push - push a value into the DatabaseArray
                 *
                 */
                DatabaseArray.prototype.get = function (key) {
                    if (typeof key == "string")
                        return this.get(key.split(/[.\[\]]/g));
                    else if (typeof key == "number")
                        return this._data[key];
                    else {
                        if (key.length > 1) {
                            var e = this._data[key[0]];
                            if (!(e instanceof value_object_4.DatabaseObject || e instanceof DatabaseArray))
                                return undefined;
                            return e === null || e === void 0 ? void 0 : e.get(key.slice(1, key.length));
                        }
                        else {
                            return this._data[typeof key[0] == "string" ? parseInt(key[0]) : key[0]];
                        }
                    }
                };
                /**
                 * Gets a value from the DatabaseArray normalizes it
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to get
                 * @returns the value of the key
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.set - sets a value from the DatabaseArray
                 * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
                 * @see DatabaseArray.get - gets a value from the DatabaseArray
                 * @see DatabaseArray.update - updates a value from the DatabaseArray
                 * @see DatabaseArray.contains - checks if the DatabaseArray contains a value
                 * @see DatabaseArray.push - push a value into the DatabaseArray
                 *
                 */
                DatabaseArray.prototype.getNormal = function (key) {
                    return get_normal_value_1.getNormalValue(this.get(key));
                };
                /**
                 * Upates a value from the DatabaseArray.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to update
                 * @param update the funciton to update the value
                 * @returns the DatabaseArray itself, so you can chain operations like that
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.set - sets a value from the DatabaseArray
                 * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
                 * @see DatabaseArray.getNormal - gets a value from the DatabaseArray and normalizes it
                 * @see DatabaseArray.get - gets a value from the DatabaseArray
                 * @see DatabaseArray.contains - checks if the DatabaseArray contains a value
                 * @see DatabaseArray.push - push a value into the DatabaseArray
                 *
                 */
                DatabaseArray.prototype.update = function (key, update) {
                    this.set(key, update(this.get(key)));
                    return this;
                };
                /**
                 * Checks if the DatabaseArray contains a value
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to check
                 * @returns does the array contains the value
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.set - sets a value from the DatabaseArray
                 * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
                 * @see DatabaseArray.get - gets a value from the DatabaseObject
                 * @see DatabaseArray.getNormal - gets a value from the DatabaseArray and normalizes it
                 * @see DatabaseArray.update - updates a value from the DatabaseObject
                 * @see DatabaseArray.push - push a value into the DatabaseArray
                 *
                 */
                DatabaseArray.prototype.contains = function (key) {
                    if (typeof key == "string")
                        return this.contains(key.split(/[.\[\]]/g));
                    else if (typeof key == "number")
                        return this._data[key] != null;
                    else {
                        if (key.length > 1) {
                            var e = this._data[key[0]];
                            if (!(e instanceof value_object_4.DatabaseObject || e instanceof DatabaseArray))
                                return false;
                            return e === null || e === void 0 ? void 0 : e.contains(key.slice(1, key.length));
                        }
                        else {
                            return (this._data[typeof key[0] == "string" ? parseInt(key[0]) : key[0]]) != null;
                        }
                    }
                };
                /**
                 * Pushs a value into the DatabaseArray
                 *
                 * @author Nicolas Schmidt
                 * @param value the value to push into the array
                 * @returns the DatabaseArray itself, so you can chain operations like that
                 *
                 * @see DatabaseArray - 👩‍👦 the parent class
                 * @see DatabaseArray.set - sets a value from the DatabaseArray
                 * @see DatabaseArray.setDefault - sets default a value from the DatabaseArray
                 * @see DatabaseArray.get - gets a value from the DatabaseArray
                 * @see DatabaseArray.getNormal - gets a value from the DatabaseArray and normalizes it
                 * @see DatabaseArray.update - updates a value from the DatabaseArray
                 * @see DatabaseArray.contains - checks if the DatabaseArray contains a value
                 *
                 */
                DatabaseArray.prototype.push = function () {
                    var _a;
                    var values = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        values[_i] = arguments[_i];
                    }
                    (_a = this._data).push.apply(_a, values.map(function (v) { return create_database_value_1.createDatabaseValue(v); }));
                    return this;
                };
                return DatabaseArray;
            }());
            exports_5("DatabaseArray", DatabaseArray);
        }
    };
});
System.register("database/value_object", ["database/value_array", "database/create_database_value", "database/get_normal_value", "database/_functions"], function (exports_6, context_6) {
    "use strict";
    var value_array_4, create_database_value_2, get_normal_value_2, _functions_2, DatabaseObject;
    var __moduleName = context_6 && context_6.id;
    return {
        setters: [
            function (value_array_4_1) {
                value_array_4 = value_array_4_1;
            },
            function (create_database_value_2_1) {
                create_database_value_2 = create_database_value_2_1;
            },
            function (get_normal_value_2_1) {
                get_normal_value_2 = get_normal_value_2_1;
            },
            function (_functions_2_1) {
                _functions_2 = _functions_2_1;
            }
        ],
        execute: function () {
            /**
             * A DatabaseObject is the database-representation of an object.
             *
             * @author Nicolas Schmidt
             *
             * @see DatabaseObject.data
             * @see DatabaseObject.constructor
             * @see DatabaseObject.set
             * @see DatabaseObject.get
             * @see DatabaseObject.update
             */
            DatabaseObject = /** @class */ (function () {
                /**
                 * Constructor for DatabaseObject
                 *
                 * @author Nicolas Schmidt
                 * @param data the data for the database-array
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.data - the argument you give to the constructor
                 *
                 */
                function DatabaseObject(data) {
                    if (data === void 0) { data = {}; }
                    this.data = data;
                }
                Object.defineProperty(DatabaseObject.prototype, "data", {
                    get: function () {
                        var _this = this;
                        var data = {};
                        Object.keys(this._data).forEach(function (k) { return data[k] = get_normal_value_2.getNormalValue(_this._data[k]); });
                        return data;
                    },
                    /**
                     * The data of the DatabaseObject
                     *
                     * @author Nicolas Schmidt
                     *
                     * @see DatabaseObject - 👩‍👦 the parent class
                     * @see DatabaseObject._data - the storage for the data
                     *
                     */
                    set: function (data) {
                        var _this = this;
                        this._data = [];
                        Object.keys(data).forEach(function (k) { return _this._data[k] = create_database_value_2.createDatabaseValue(data[k]); });
                    },
                    enumerable: false,
                    configurable: true
                });
                Object.defineProperty(DatabaseObject.prototype, "length", {
                    /**
                     * Returns the length of the object
                     *
                     * @author Nicolas Schmidt
                     *
                     * @see DatabaseArray - 👩‍👦 the parent class
                     * @see DatabaseArray.data - the data of the array
                     *
                     */
                    get: function () {
                        return Object.keys(this._data).length;
                    },
                    enumerable: false,
                    configurable: true
                });
                /**
                 * Sets a value from the DatabaseObject.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to apply the value to
                 * @param value the value to apply to the given path
                 * @returns the DatabaseObject itself, so you can chain operations like that
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.get - gets a value from the DatabaseObject
                 * @see DatabaseObject.getNormal - gets a normalized value from the DatabaseObject
                 * @see DatabaseObject.update - updates a value from the DatabaseObject
                 * @see DatabaseObject.contains - checks if the DatabaseObject contains a value
                 *
                 */
                DatabaseObject.prototype.set = function (key, value) {
                    if (typeof key == "string")
                        return this.set(key.split(/[.\[\]]/g), value);
                    else {
                        if (key.length > 1) {
                            if (this._data[key[0]] == null)
                                this._data[key[0]] = _functions_2.createObjectForKey(key);
                            var e = this._data[key[0]];
                            if (!(e instanceof DatabaseObject || e instanceof value_array_4.DatabaseArray))
                                throw new Error("Can't use set property of " + typeof e);
                            e.set(key.slice(1, key.length), value);
                        }
                        else {
                            this._data[key[0]] = create_database_value_2.createDatabaseValue(value);
                        }
                    }
                    return this;
                };
                /**
                 * Sets a default value from the DatabaseObject.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to apply the value to
                 * @param value the value to apply to the given path
                 * @returns the DatabaseObject itself, so you can chain operations like that
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.set - sets a value from the DatabaseObject
                 * @see DatabaseObject.get - gets a value from the DatabaseObject
                 * @see DatabaseObject.update - updates a value from the DatabaseObject
                 * @see DatabaseObject.contains - checks if the DatabaseObject contains a value
                 *
                 */
                DatabaseObject.prototype.setDefault = function (key, value) {
                    if (!this.contains(key))
                        this.set(key, value);
                    return this;
                };
                /**
                 * Sets default values for the DatabaseObject.
                 *
                 * @author Nicolas Schmidt
                 * @param defaults an object containing all the default values
                 * @returns the DatabaseObject itself, so you can chain operations like that
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.set - sets a value from the DatabaseObject
                 * @see DatabaseObject.get - gets a value from the DatabaseObject
                 * @see DatabaseObject.update - updates a value from the DatabaseObject
                 * @see DatabaseObject.contains - checks if the DatabaseObject contains a value
                 *
                 */
                DatabaseObject.prototype.setDefaults = function (defaults) {
                    var _this = this;
                    Object.keys(defaults).forEach(function (k) {
                        if (!_this._data[k])
                            _this._data[k] = create_database_value_2.createDatabaseValue(defaults[k]);
                        else if (defaults[k] instanceof Object && _this._data[k] instanceof DatabaseObject)
                            _this._data[k].setDefaults(defaults[k]);
                    });
                    return this;
                };
                /**
                 * Gets a value from the DatabaseObject.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to get
                 * @returns the value at the position
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.set - sets a value from the DatabaseObject
                 * @see DatabaseObject.getNormal - gets a normalized value from the DatabaseObject
                 * @see DatabaseObject.update - updates a value from the DatabaseObject
                 * @see DatabaseObject.contains - checks if the DatabaseObject contains a value
                 *
                 */
                DatabaseObject.prototype.get = function (key) {
                    if (typeof key == "string")
                        return this.get(key.split(/[.\[\]]/g));
                    else {
                        if (key.length > 1) {
                            var e = this._data[key[0]];
                            if (!(e instanceof DatabaseObject || e instanceof value_array_4.DatabaseArray))
                                return undefined;
                            return e === null || e === void 0 ? void 0 : e.get(key.slice(1, key.length));
                        }
                        else {
                            return this._data[key[0]];
                        }
                    }
                };
                /**
                 * Gets a value from the DatabaseObject and normalizes it
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to get
                 * @returns the normalized value at the position
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.set - sets a value from the DatabaseObject
                 * @see DatabaseObject.get - gets a value from the DatabaseObject
                 * @see DatabaseObject.update - updates a value from the DatabaseObject
                 * @see DatabaseObject.contains - checks if the DatabaseObject contains a value
                 *
                 */
                DatabaseObject.prototype.getNormal = function (key) {
                    return get_normal_value_2.getNormalValue(this.get(key));
                };
                /**
                 * Updates a value from the DatabaseObject.
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to update
                 * @param update the function to update the value
                 * @returns the DatabaseObject itself, so you can chain operations like that
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.set - sets a value from the DatabaseObject
                 * @see DatabaseObject.get - gets a value from the DatabaseObject
                 * @see DatabaseObject.contains - checks if the DatabaseObject contains a value
                 *
                 */
                DatabaseObject.prototype.update = function (key, update) {
                    this.set(key, update(this.get(key)));
                    return this;
                };
                DatabaseObject.prototype.generateId = function (name) {
                    var counter = "id_counters." + name;
                    if (this.get(counter) == null)
                        this.set(counter, -1);
                    return this.update(counter, function (e) { return e + 1; }).get(counter);
                };
                /**
                 * Checks if the DatabaseObject contains a value
                 *
                 * @author Nicolas Schmidt
                 * @param key the path to apply the value to
                 * @returns the value at the position of the position
                 *
                 * @see DatabaseObject - 👩‍👦 the parent class
                 * @see DatabaseObject.set - sets a value from the DatabaseObject
                 * @see DatabaseObject.get - gets a value from the DatabaseObject
                 * @see DatabaseObject.update - updates a value from the DatabaseObject
                 *
                 */
                DatabaseObject.prototype.contains = function (key) {
                    if (typeof key == "string")
                        return this.contains(key.split(/[.\[\]]/g));
                    else {
                        if (key.length > 1) {
                            var e = this._data[key[0]];
                            if (!(e instanceof DatabaseObject || e instanceof value_array_4.DatabaseArray))
                                return false;
                            return e === null || e === void 0 ? void 0 : e.contains(key.slice(1, key.length));
                        }
                        else {
                            return this._data[key[0]] != null;
                        }
                    }
                };
                return DatabaseObject;
            }());
            exports_6("DatabaseObject", DatabaseObject);
        }
    };
});
System.register("database/database_async", ["database/value_object"], function (exports_7, context_7) {
    "use strict";
    var value_object_5, Database;
    var __moduleName = context_7 && context_7.id;
    return {
        setters: [
            function (value_object_5_1) {
                value_object_5 = value_object_5_1;
            }
        ],
        execute: function () {
            /**
             * Database class is basically a DatabaseObject with save and load functionality
             *
             * @see SyncDatabase
             * @see Database.saveData
             * @see Database.reloadData
             *
             * @see DatabaseObject
             * @see DatabaseObject.data
             * @see DatabaseObject.constructor
             * @see DatabaseObject.set
             * @see DatabaseObject.get
             * @see DatabaseObject.update
             */
            Database = /** @class */ (function (_super) {
                __extends(Database, _super);
                /**
                 * Constructor for Database class
                 *
                 * @author Nicolas Schmidt
                 * @param adapter the adapter to get the data from / save the data to
                 * @param data the data to create the database with
                 *
                 * @see Database - 👩‍👦 the parent class
                 */
                function Database(adapter, data) {
                    var _this = _super.call(this, data) || this;
                    _this.adapter = adapter;
                    _this.adapter = adapter;
                    return _this;
                }
                /**
                 * Save the data from the database
                 *
                 * @author Nicolas Schmidt
                 * @returns ⌛ Promise (Ready when saved) >> the database itself, so you can chain operations
                 */
                Database.prototype.saveData = function () {
                    return __awaiter(this, void 0, void 0, function () { return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.adapter.save(this.data)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/, this];
                        }
                    }); });
                };
                /**
                 * Reload the data from the database
                 *
                 * @author Nicolas Schmidt
                 * @returns ⌛ Promise (Ready when loaded) >> the database itself, so you can chain operations
                 */
                Database.prototype.reloadData = function () {
                    return __awaiter(this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _a = this;
                                return [4 /*yield*/, this.adapter.load()];
                            case 1:
                                _a.data = _b.sent();
                                return [2 /*return*/, this];
                        }
                    }); });
                };
                return Database;
            }(value_object_5.DatabaseObject));
            exports_7("Database", Database);
        }
    };
});
System.register("database/database_sync", ["database/value_object"], function (exports_8, context_8) {
    "use strict";
    var value_object_6, SyncDatabase;
    var __moduleName = context_8 && context_8.id;
    return {
        setters: [
            function (value_object_6_1) {
                value_object_6 = value_object_6_1;
            }
        ],
        execute: function () {
            /**
             * SyncDatabase is a database that does not use promises.
             *
             * @see Database
             * @see SyncDatabase.saveData
             * @see SyncDatabase.reloadData
             *
             * @see DatabaseObject
             * @see DatabaseObject.data
             * @see DatabaseObject.constructor
             * @see DatabaseObject.set
             * @see DatabaseObject.get
             * @see DatabaseObject.update
             */
            SyncDatabase = /** @class */ (function (_super) {
                __extends(SyncDatabase, _super);
                /**
                 * Constructor for Database class
                 *
                 * @author Nicolas Schmidt
                 * @param adapter the adapter to get the data from / save the data to
                 * @param data the data to create the database with
                 *
                 * @see Database - 👩‍👦 the parent class
                 */
                function SyncDatabase(adapter, data) {
                    var _this = _super.call(this, data || adapter.load()) || this;
                    _this.adapter = adapter;
                    _this.adapter = adapter;
                    return _this;
                }
                /**
                 * Save the data from the database
                 *
                 * @author Nicolas Schmidt
                 * @returns the database itself, so you can chain operations
                 */
                SyncDatabase.prototype.saveData = function () { this.adapter.save(this.data); return this; };
                /**
                 * Reload the data from the database
                 *
                 * @author Nicolas Schmidt
                 * @returns the database itself, so you can chain operations
                 */
                SyncDatabase.prototype.reloadData = function () { this.data = this.adapter.load(); return this; };
                return SyncDatabase;
            }(value_object_6.DatabaseObject));
            exports_8("SyncDatabase", SyncDatabase);
        }
    };
});
System.register("database/create_database", ["database/database_async", "database/database_sync"], function (exports_9, context_9) {
    "use strict";
    var database_async_1, database_sync_1;
    var __moduleName = context_9 && context_9.id;
    function createDatabase(adapter) {
        var result = adapter.load();
        if (result instanceof Promise) {
            return new Promise(function (rs) {
                result.then(function (data) {
                    rs(new database_async_1.Database(adapter, data));
                });
            });
        }
        return new database_sync_1.SyncDatabase(adapter, result);
    }
    exports_9("createDatabase", createDatabase);
    return {
        setters: [
            function (database_async_1_1) {
                database_async_1 = database_async_1_1;
            },
            function (database_sync_1_1) {
                database_sync_1 = database_sync_1_1;
            }
        ],
        execute: function () {
        }
    };
});
System.register("database", ["database/create_database", "database/create_database_value", "database/database_async", "database/database_sync", "database/get_normal_value", "database/types", "database/value_array", "database/value_object"], function (exports_10, context_10) {
    "use strict";
    var __moduleName = context_10 && context_10.id;
    function exportStar_1(m) {
        var exports = {};
        for (var n in m) {
            if (n !== "default") exports[n] = m[n];
        }
        exports_10(exports);
    }
    return {
        setters: [
            function (create_database_1_1) {
                exportStar_1(create_database_1_1);
            },
            function (create_database_value_3_1) {
                exportStar_1(create_database_value_3_1);
            },
            function (database_async_2_1) {
                exportStar_1(database_async_2_1);
            },
            function (database_sync_2_1) {
                exportStar_1(database_sync_2_1);
            },
            function (get_normal_value_3_1) {
                exportStar_1(get_normal_value_3_1);
            },
            function (types_1_1) {
                exportStar_1(types_1_1);
            },
            function (value_array_5_1) {
                exportStar_1(value_array_5_1);
            },
            function (value_object_7_1) {
                exportStar_1(value_object_7_1);
            }
        ],
        execute: function () {
        }
    };
});
//# sourceMappingURL=src/sourcemaps/index.js.map